package raptor;

import universum.bi.*;
import java.util.Vector;

/**
 * Created by IntelliJ IDEA.
 * User: Tanya
 * Date: 27.12.2006
 * Time: 22:38:22
 */
public class Manager {
    private final Vector<Raptor> creatureList = new Vector<Raptor>();
    private int turn = 0;
    private int turnCounter = 0;

    public void register(Raptor r) {
        creatureList.add(r);
    }

    public void unregister(Raptor r) {
        creatureList.remove(r);
    }

    // Not synchoronized procs!!!
    public int getCreatureCount() {
        return creatureList.size();
    }

    public synchronized int getTurn() {
        return turn;
    }

    public void setTurn(int turn) {
        this.turn = turn;
    }

    public int getTurnCounter() {
        return turnCounter;
    }

    public void setTurnCounter(int turnCounter) {
        this.turnCounter = turnCounter;
    }

    // dynamically extendable glade info array
    public WorldCell [][] world;

    public void init() {
        world = new WorldCell[Constants.getWidth()][Constants.getHeight()];
        for (int i=0; i<world.length; ++i) {
            for (int j=0; j<world[i].length; ++j) {
                world[i][j] = new WorldCell();
            }
        }
    }

    public synchronized void updateWorld(PointInfo info, Being being) {
        Location pos    = info.getLocation();
        WorldCell cell  = world[pos.getX()][pos.getY()];
        
        cell.explored   = true;
        cell.growth     = info.getGrowthRate(being);
    }

    public void test(BeingInterface bi) {
        for (Being b : creatureList) {
            PointInfo pi = bi.getPointInfo(b);
            bi.log(b, "info=" + pi.getMaxCount(b));
        }
    }
}
