package universum.bi;

/**
 *
 * @author nike
 */
public interface Being extends Entity {
    // invoked once per externally added being before game start, 
    // usually shall be used to reinitialize static variables
    void reinit(UserGameInfo info);
    // return being's name, could be anything, for unique id 
    // use id returned by BeingInterface.getId(Entity e)
    String       getName();
    // return player's name owning this being 
    // (used only once to create first being, all others inherit same owner)
    String       getOwnerName();
    // return parameters of this being 
    // (used only once to create first being, for others BeingParams defined
    // by parent (argument to BEING_BORN event) )
    BeingParams  getParams();
}
