package universum.bi;

import java.util.List;
import universum.engine.*;

/**
 * This interface defines everything being knows about reality it lives in.
 * For random numbers see universum.util.Util (don't use java.util.random() or custom
 * implementation for reproducablity resons).
 *
 * @author nike
 */
public interface BeingInterface extends EntityInterface {
    // get owner's handle, for simple FoF detection
    public Object          getOwner(Being me, Integer id);
    // get being mass
    public float           getMass(Being me, Integer id);
    // get my current energy level
    public float           getEnergy(Being me);
    // get information about point I'm in
    public PointInfo       getPointInfo(Being me);
    // get information about my heighbourhood
    public List<PointInfo> getNeighbourInfo(Being me);
    // get the locations we can go to in one turn
    public List<Location>  getReachableLocations(Being me);
    // logging
    public void            log(Being me, String s);
}
