package universum.bi;

import universum.engine.*;

/**
 * Everything in the world should implement this interface
 * @author nike
 */
public interface Entity {
    // handles an event, we pass being interface as at supercedes EntityInterface
    public void processEvent(BeingInterface bi, Event e);
    // make this entity's turn, returned value is an event describing
    // action this being is planning to perform, see EventKind for possible events
    public Event makeTurn(BeingInterface bi);
}
