package universum.engine;

import java.io.PrintStream;

import universum.bi.Constants;
import universum.bi.GameKind;

// pure data class defining config of game
public final class GameInfo {    
    public GameKind gameKind;
    public int maxTurns;
    public int turnDelay;
    public int waitBefore, waitAfter;
    public String recordGameFilePath;
    public int fieldWidth;
    public int fieldHeight;
    public int numRegular;
    public int numGolden;
    public float maxRegular;
    public float maxGolden;
    public float growRegular;
    public float growGolden;
    public PrintStream out;

    public GameInfo() {
        gameKind = Constants.getDebug() ? GameKind.DEBUG : GameKind.JUNGLE;
        maxTurns = Constants.getMaxTurns();
        recordGameFilePath = Constants.getRecordFile();
        fieldWidth = Constants.getWidth();
        fieldHeight = Constants.getHeight();
        numRegular = Constants.NUM_REGULAR;
        numGolden = Constants.NUM_GOLDEN;
        maxRegular = Constants.MAX_REGULAR;
        maxGolden = Constants.MAX_GOLDEN;
        growRegular = Constants.GROW_REGULAR;
        growGolden = Constants.GROW_GOLDEN;
        turnDelay = Constants.getTurnDelay();
        out = System.out;
        waitBefore = 0;
        waitAfter = 5 * 60 * 1000;
    }

}
