package universum.engine;

/**
 *
 * @author nike
 */
public final class ScoreData implements Comparable<ScoreData> {
    public String jarFile;
    public String player;
    public float  score;
    public float  energy;
    public int    id; // unique id of particluar player
    public boolean alive;
    private static int curId = 0;
    
    public ScoreData(String player, String jarFile) {
        this.player = player;
        this.score  = 0.0f;
        this.energy = 0.0f;
        this.alive = true;
        this.id = curId++;
        this.jarFile = jarFile;
    }

    static void reset() {
        curId = 0;
    }

    public int compareTo(ScoreData other) {
        float thisVal = this.score;
        float otherVal = other.score;
        return (thisVal > otherVal ? -1 : (thisVal == otherVal ? 0 : 1));
    }

}
