package universum.engine;

import java.util.List;
import universum.bi.Location;
import universum.util.Walker;

/**
 *
 * @author nike
 */
public interface Topology {
    public void init(Universe u);
    
    public void walkSpace(Walker<Location> walker);
    public Location getRandomLocation();
    public List<Location> getNeighbours(Location loc);
    public List<Location> getNeighbours(Location loc, float radius);
    
    // those one adds metrical properties, not really belonging to the topology
    // but we need a way to represent it on 2D screen in 3D Euclidian space (what a mess!)
    public List<Integer> diameters();
    public float distance(Location one, Location other);

    public boolean contains(Location x);
}
